<?php if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly 
	function sanitize_eufdc_data( $input ) {

		if(is_array($input)){
		
			$new_input = array();
	
			foreach ( $input as $key => $val ) {
				$new_input[ $key ] = (is_array($val)?sanitize_eufdc_data($val):sanitize_text_field( $val ));
			}
			
		}else{
			$new_input = sanitize_text_field($input);
		}
		
		return $new_input;
	}
	
	global $easy_ufdc_page, $wufdc_dir, $wufdc_pro_file, $ufdc_custom;        

	if($ufdc_custom)
	include_once($wufdc_pro_file);
	
	//echo include_once($wufdc_pro_file);exit;
	
	function wufdc_admin_enqueue_script(){
	    wp_enqueue_script( 'wufdc_scripts', plugin_dir_url( dirname(__FILE__) ) . 'js/admin_scripts.js' );
		wp_enqueue_style( 'wufdc-style', plugins_url('css/admin.css', dirname(__FILE__)), array(), date('Yhmi'));
	}
	
	
	/*if(!function_exists('wc_add_notice')){
		function wc_add_notice($error, $domain){
			
			return $error;
			
		}	 
	} 	*/
	if(!function_exists('pre')){
	function pre($data){
			if(isset($_GET['debug'])){
				pree($data);
			}
		}	 
	} 	

	if(!function_exists('pree')){
	function pree($data){
				echo '<pre>';
				print_r($data);
				echo '</pre>';	
		}	 
	} 
	
	if(!function_exists('eufdc_get_parent_post_id')){
		function eufdc_get_parent_post_id(){
			global $wpdb, $woocommerce, $eufdc_default_parent_post_id;
			
			

			$wc = (array)$woocommerce->session;

			$wc = array_values($wc);	
			
			$parent_post_id = $wc[1];

			$cart_contents = (isset($woocommerce->cart) && is_object($woocommerce->cart) && isset($woocommerce->cart->cart_contents) && is_array($woocommerce->cart->cart_contents))?$woocommerce->cart->cart_contents:array();

			if(!empty($cart_contents) && isset($wc[1])){
				$wpdb->query('UPDATE '.$wpdb->posts.' SET post_parent="'.$parent_post_id.'" WHERE post_parent="'.$eufdc_default_parent_post_id.'"');	
			}else{
				$parent_post_id = $eufdc_default_parent_post_id;
			}

			
			return $parent_post_id;
			
		}
	}
		
	if(!function_exists('get_eufdc_uploaded_files')){
		function get_eufdc_uploaded_files($author_id=0, $postid=0){
			
			
			$files = array();			
			$uploaded = array();
			


			$args = array( 'posts_per_page' => -1, 'offset'=>0, 'post_type'=>'attachment', 'post_status'=>'inherit', 'post_parent'=>eufdc_get_parent_post_id(), 'order_by'=>'title', 'order'=>'ASC' );
			
			//pree($args);
			
			if($postid){
				$args['include'] = array($postid);
				//unset($args['post_parent']);
			}
			if($author_id){
				$args['author'] = $author_id;
			}					
			$files_arr = get_posts( $args );	
			//pree($files_arr);
			if(!empty($files_arr)){
				foreach($files_arr as $fi=>$f_arr){
					$f_arr->eufc_index = get_post_meta($f_arr->ID, 'eufdc_index', true);
					$files[$fi] = $f_arr;
				}
			}
			
			
			
		
			
			return $files;
		}
	}
	
	if(!function_exists('add_file_to_upcoming_order')){
		function add_file_to_upcoming_order($inside=false){
			
			
			$files = get_eufdc_uploaded_files();	
			$uploaded = array();


			if(!empty($files)){
				foreach($files as $my_files){
					$eufdc_index = get_post_meta($my_files->ID, 'eufdc_index', true);
					$url = eufdc_secure_download_link($my_files->ID, 0, $my_files->guid);
					$uploaded[] = '<li class="ready" eufdc_index="'.$eufdc_index.'"><a href="'.$url.'" target="_blank">'.$my_files->post_title.'</a> <a class="delete" href="?eufdc-delete='.$my_files->ID.'"><small>'.__('Delete').'</small></a></li>';
				}
			}
	
		
			
	
		?>
		<div id="wufdc_div">
			<h6><?php echo stripslashes(get_option( 'easy_ufdc_caption' )); ?></h6><br />
			
            
            

<ul>
		<?php if(!empty($uploaded)){ echo implode('', $uploaded);  }else{ ?>

        

        <li><input type="file" name="file_during_checkout" /></li>
<?php
		}
?>        
</ul>   
    
</div>
            
            <div class="wufdc_legends <?php echo($inside?'i_s':'o_s'); ?>">
            <small class="afs"><?php _e('Allowed filesize'); ?>: <?php echo get_option( 'easy_ufdc_max_uploadsize' ); ?></small><br />
            <small class="aft"><?php _e('Allowed file'); ?>: <?php echo get_option( 'easy_ufdc_allowed_file_types' ); ?></small>
            </div>
            <?php //if(!$inside): ?>
	  		<script type="text/javascript">jQuery(document).ready(function(){ if(!eufdc_in_action){ layered_js2(jQuery);	} });</script>    
			 <?php //endif; ?>
		<?php	
		}
	}

	if(!function_exists('easy_ufdc_admin_menu')){
		function easy_ufdc_admin_menu() {
			$page = add_submenu_page('woocommerce', 'Upload Files During Checkout', 'Easy Upload Files', 'manage_woocommerce', 'easy_ufdc', 'easy_ufdc_page' );
		}	
	}

	function wufdc_enqueue_style() {
		wp_enqueue_style(
			'wufdc-style',
			plugins_url('css/style.css', dirname(__FILE__)),
			array(),
			date('Ymdhi')
		);
	}

	function wufdc_enqueue_script() {
		global $woocommerce, $easy_ufdc_req, $easy_ufdc_error_default, $easy_ufdc_page, $ufdc_custom, $easy_ufdc_page_checkout_refresh;

		$cart_url = (function_exists('wc_get_cart_url')?wc_get_cart_url():$woocommerce->cart->get_cart_url());
		$checkout_url = (function_exists('wc_get_checkout_url')?wc_get_checkout_url():$woocommerce->cart->get_checkout_url());
		// Register the script


		// Localize the script with new data
		$easy_ufdc_max_uploadsize = get_option( 'easy_ufdc_max_uploadsize', ini_get('upload_max_filesize') );
		$easy_ufdc_max_uploadsize = filter_var($easy_ufdc_max_uploadsize, FILTER_SANITIZE_NUMBER_INT);
		
		$doctypes = explode( ',', get_option( 'easy_ufdc_allowed_file_types' ) );
		$doctypes=array_map('trim',$doctypes);

		$REQUEST_URI = $_SERVER['REQUEST_URI'];
		$is_checkout = strpos($checkout_url, $REQUEST_URI);
		$is_cart = strpos($cart_url, $REQUEST_URI);

								
		$translation_array = array(
			'cart_url' => $cart_url,
			'checkout_url' => $checkout_url,
			'is_cart' => (is_cart()),// || $is_cart),
			'is_checkout' => (is_checkout()),// || $is_checkout),			
			'is_product' => (is_product()),
			'max_uploadsize' => $easy_ufdc_max_uploadsize,
			'max_uploadsize_bytes' => ($easy_ufdc_max_uploadsize*1024*1024),
			'allowed_filetypes' => implode(',', $doctypes),
			'url' => plugin_dir_url( dirname(__FILE__) ),
			'easy_ufdc_req' => $easy_ufdc_req,
			'progress_text' => __('Uploading your files, please wait for the system to continue.','easy-upload-files-during-checkout'),
			'progress_error' => '<span class="green">'.__('Uploaded your files, please wait for the system to continue.','easy-upload-files-during-checkout').'</span>',
			'error_default' => $easy_ufdc_error_default,
			'easy_ufdc_page' => $easy_ufdc_page,
			'is_custom' => $ufdc_custom,
			'uploaded_files' => count(get_eufdc_uploaded_files()),
			'ajax_url' => admin_url( 'admin-ajax.php' ),
			'checkout_refresh' => $easy_ufdc_page_checkout_refresh,
			'upload_anim' => ($ufdc_custom?get_option( 'woocommerce_ufdc_upload_anim', 'default.gif'):'default.gif'),
			'eufdc_secure_upload' => get_option('eufdc_secure_upload', 0)?'Y':'N',
			'eufdc_secure_upload_error' => __('Sorry, you need to login/register to upload files.','easy-upload-files-during-checkout'),
			'is_user_logged_in' => is_user_logged_in()?'Y':'N'
		);
		
		$translation_array['is_woocommerce'] = (is_woocommerce() || $translation_array['is_cart'] || $translation_array['is_checkout']);
		
		if($ufdc_custom && function_exists('get_eufdc_min_max_dimensions')){
			$eufdc_min_max_dimensions = get_eufdc_min_max_dimensions();
				
			$translation_array['min_max_dimensions'] = $eufdc_min_max_dimensions;
			
		}

		

		wp_register_script( 'eufdc', plugins_url('js/scripts.js', dirname(__FILE__)), array('jquery'), time());
		wp_localize_script( 'eufdc', 'eufdc_obj', $translation_array );
		// Enqueued script with localized data.
		wp_enqueue_script( 'jquery' );
		wp_enqueue_script( 'eufdc' );			

		/*wp_enqueue_script(
			'eufdc',
			plugins_url('js/scripts.js', __FILE__),
			array('jquery')
		);*/	

	}

	if(!function_exists('ufdc_file_during_checkout')){
		function ufdc_file_during_checkout(){
		
			
			$ret = (isset($_FILES['file_during_checkout']['name']) && $_FILES['file_during_checkout']['error']==0)?true:false;

			return $ret;
		}
	}
	
	function ufdc_custom_init(){
		if(isset($_GET['eufdc-delete']) && is_numeric($_GET['eufdc-delete'])){


			global $ufdc_limit;

			
			$postid = isset($_GET['eufdc-delete'])?$_GET['eufdc-delete']:0;
			
			if($postid){
			
				$user_id = 0;
				if(is_user_logged_in()){
					$current_user = wp_get_current_user();
					$user_id = $current_user->ID;
				}
				
				$files = get_eufdc_uploaded_files($user_id, $postid);
			
				
				if(!empty($files)){
	
					$force_delete = true;
					wp_delete_post( $postid, $force_delete );
					wp_delete_attachment( $postid, $force_delete );
				
				}
			
			}
			
		}
	}

	if(!function_exists('ufdc_custom_file_upload')){
	 	function ufdc_custom_file_upload() {
			
			
			
			if(is_admin())
			return;
			
			global $easy_ufdc_page, $easy_ufdc_req, $easy_ufdc_error;

			
			
			
			if(isset($_SERVER['HTTP_REFERER'])) {
				$same_page = (stristr($_SERVER['HTTP_REFERER'], $_SERVER['REQUEST_URI']));
			}else{
				$same_page = false;
			}			
			//exit;
			if($same_page && !empty($_POST) && $easy_ufdc_req && !ufdc_file_during_checkout()){	
				
				switch($easy_ufdc_page){			
					case 'checkout':
					case 'checkout_notes':
						if(strpos($_SERVER['REQUEST_URI'], '/checkout')>0){
							wc_add_notice( $easy_ufdc_error, 'error' );				
						}
					break;

					case 'cart':
					case '':
						if(strpos($_SERVER['REQUEST_URI'], '/cart')>0){
							wc_add_notice( $easy_ufdc_error, 'error' );					
						}
					break;
				}
			}
		}
	}


	if(!function_exists('ufdc_easy_ufdc_req')){	
		function ufdc_easy_ufdc_req(){
			global $woocommerce;
?>
		<script type="text/javascript" language="javascript">
			jQuery(document).ready(function($){
				var eufdc_elem = 'input[name^="file_during_checkout"]:visible';
				if($(eufdc_elem).length>0){
					$('body').on('change', eufdc_elem, function(){
						$('form[method="post"]').attr('action', '<?php echo $woocommerce->cart->get_checkout_url(); ?>');
					});
					
					
					var act = setInterval(function(){
						$.each($(eufdc_elem).closest('form'), function(){
							var attr = $(this).attr('action');
							if (typeof attr !== typeof undefined && attr !== false) {
								$(this).removeAttr('action');
								clearInterval(act);
							}
						});
					}, 1000);					
				}
			});
		</script>
<?php			
		}
	}	

	if(!function_exists('file_during_checkout')){
		function file_during_checkout(){
			
			global $wpdb, $easy_ufdc_page, $woocommerce, $easy_ufdc_req, $easy_ufdc_error;
            
            $eufdc_parent_post_id = eufdc_get_parent_post_id();

			$REQUEST_URI = $_SERVER['REQUEST_URI'];
			if(
				!empty($_FILES) 
			&& 
				!is_admin() 
			&&
				(
					(
						$easy_ufdc_req 
						&& 
						array_key_exists('file_during_checkout', $_FILES)
						)
						||
						array_key_exists('file_during_checkout', $_FILES)
					)
			){	
			
				
				$cart_url = (function_exists('wc_get_cart_url')?wc_get_cart_url():$woocommerce->cart->get_cart_url());
				$checkout_url = (function_exists('wc_get_checkout_url')?wc_get_checkout_url():$woocommerce->cart->get_checkout_url());				
				
				$is_checkout = strpos($checkout_url, $REQUEST_URI);
				$is_cart = strpos($cart_url, $REQUEST_URI);
			
				if($is_checkout || $is_cart){
					switch($easy_ufdc_page){
						case 'checkout':		
						case 'checkout_notes':				
							$redir = $checkout_url;
						break;
						case 'cart':
						default:					
							$redir = $cart_url;
						break;
					}		
	

	
					if($easy_ufdc_req && !ufdc_file_during_checkout()){
						wc_add_notice(sprintf( $easy_ufdc_error, $ext ), 'error');
						wp_redirect($redir);
						exit;
					}elseif(ufdc_file_during_checkout()){
						$file_during_checkout = $_FILES['file_during_checkout']['name'];
						$file_during_checkout = explode('.', $file_during_checkout);
						$ext = end($file_during_checkout);
						$doctypes = explode( ',', get_option( 'easy_ufdc_allowed_file_types' ) );
						$doctypes=array_map('trim',$doctypes);

						if(!empty($ext) && !in_array($ext, $doctypes)){
							wc_add_notice(sprintf( __( 'The "%s" file type is not allowed.','easy-upload-files-during-checkout'), $ext ), 'error');
							wp_redirect($redir);
							exit;
						}
	
						if ( ! function_exists( 'wp_handle_upload' ) ) require_once( ABSPATH . 'wp-admin/includes/file.php' );
						$uploadedfile = $_FILES['file_during_checkout'];

						$upload_overrides = array( 'test_form' => false );
						$movefile = wp_handle_upload( $uploadedfile, $upload_overrides );

						if(!empty($movefile)){					

							$myposts = $wpdb->get_results("
								SELECT 
									$wpdb->posts.* 
								FROM 
									$wpdb->posts                                     				
								WHERE 
									$wpdb->posts.post_parent = '".$eufdc_parent_post_id."'  
								AND 
									$wpdb->posts.post_type = 'attachment' 
								AND 
									(($wpdb->posts.post_status = 'inherit')) 
								ORDER BY 
									$wpdb->posts.post_date 
								DESC 
									LIMIT 0, 1"
								);
					
							if(!empty($myposts)){
								foreach($myposts as $post){
									wp_delete_post( $post->ID, true );
								}
							}

							// $filename should be the path to a file in the upload directory.
							$filename = $movefile['file'];
						
	
							// Check the type of tile. We'll use this as the 'post_mime_type'.
							$filetype = wp_check_filetype( basename( $filename ), null );
	
							// Get the path to the upload directory.
							$wp_upload_dir = wp_upload_dir();
	
							// Prepare an array of post data for the attachment.
							$attachment = array(
								'guid'           => $movefile['url'], 
								'post_mime_type' => $filetype['type'],
								'post_title'     => preg_replace( '/\.[^.]+$/', '', basename( $filename ) ),
								'post_content'   => '',
								'post_status'    => 'inherit'
							);

							// Insert the attachment.
							$attach_id = wp_insert_attachment( $attachment, $filename, $eufdc_parent_post_id );
							add_filter( 'intermediate_image_sizes', '__return_empty_array' );
							// Make sure that this file is included, as wp_generate_attachment_metadata() depends on it.
							//require_once( ABSPATH . 'wp-admin/includes/image.php' );
	
							// Generate the metadata for the attachment, and update the database record.
							//$attach_data = wp_generate_attachment_metadata( $attach_id, $filename );
							//wp_update_attachment_metadata( $attach_id, $attach_data );
						}
					}elseif($is_cart){
							wp_redirect($checkout_url);
							exit;
					}
				}
			}
					
			
		}
	}

	function pre_wc_checkout_order_processed($post_id){
		$post = get_post($post_id); 
		$post_type = $post->post_type;
		if($post_type=='shop_order'){		
			wc_checkout_order_processed($post_id);
		}
	}

	if(!function_exists('wc_checkout_order_processed')){
		function wc_checkout_order_processed($order_id){
		
			$eufdc_get_parent_post_id = eufdc_get_parent_post_id();
				
			if($eufdc_get_parent_post_id!='' && is_numeric($eufdc_get_parent_post_id) && $eufdc_get_parent_post_id>0){
			
				$args = array( 'posts_per_page' => 1, 'offset'=>0, 'post_type'=>'attachment', 'post_status'=>'inherit', 'post_parent'=>$eufdc_get_parent_post_id );
				$myposts = get_posts( $args );	
	
				if(!empty($myposts)){
					$my_post = (array)current($myposts);
					$my_post['post_type'] = 'attachment_order';
					$my_post['post_parent'] = $order_id;
					wp_update_post( $my_post );	
					$key = 1;
					update_post_meta( $order_id, '_woo_ufdc_uploaded_file_name_' . $key, sanitize_eufdc_data($my_post['post_title']) );
					update_post_meta( $order_id, '_woo_ufdc_uploaded_file_path_' . $key, sanitize_eufdc_data(str_replace(get_bloginfo('siteurl').'/', '', $my_post['guid'])) );
					update_post_meta( $order_id, '_woo_ufdc_uploaded_product_name_' . $key, 'Order ID: '.$order_id );
				}	
				
			}
		}
	}

	if(!function_exists('init_sessions')){
		function init_sessions(){
			if (!session_id()){
				ob_start();
				@session_start();
			}
		}
	}

	if(!function_exists('easy_ufdc_add_box')){
		function easy_ufdc_add_box() {
			add_meta_box( 'easy-ufdc-box-order-detail', __( 'Attached Files','easy-upload-files-during-checkout'), 'easy_ufdc_box_order_detail', 'shop_order', 'side', 'default' );
		}
	}

	if(!function_exists('add_order_attachments')){
		function add_order_attachments(  $order, $sent_to_admin, $plain_text=false, $email='' ) {
	
			if (get_option('eufdc_email', 0) && in_array($order->post_status, array('wc-on-hold', 'wc-processing', 'wc-pending', 'wc-completed'))) {
				global $woocommerce;
				$post = $order->post;
				$ret = '<h3>'. __("Attachments",'easy-upload-files-during-checkout') . '</h3>';
				$ret .= '<ul style="padding:0; margin:0; list-style:decimal outside;">';
				$i=1;
				$j=1;
				$upload_count=0;		
				$max_upload_count=1;
				while ($i <= $max_upload_count) {
					$name = get_post_meta( $post->ID, '_woo_ufdc_uploaded_file_name_' . $j, true );	
					$uploaded_file_path = get_post_meta( $post->ID, '_woo_ufdc_uploaded_file_path_' . $j, true );	
					$uploaded_file_path = str_replace(array('http:', 'https:'), '', $uploaded_file_path);
					$url = str_replace( ABSPATH, home_url('/'),  $uploaded_file_path);
					$url = (strpos($url, home_url('/'))?$url:home_url('/').$url);
					
					$forproduct = get_post_meta( $post->ID, '_woo_ufdc_uploaded_product_name_' . $j, true );
	
					if( !empty( $url ) && !empty( $name ) ) {
						$url = eufdc_secure_download_link($post->ID, $j, $url);
						$ret .= '<li>';
						$ret .= str_replace(array('_URL', '_NAME'), array($url, $name), ($sent_to_admin?'<a href="_URL" target="_blank">':'').'_NAME'.($sent_to_admin?'</a>':'') );
						$ret .= '</li>';
						$upload_count++;
					} else {
						//silence is golden
					}
					$i++;
					$j++;
				}
				$ret .= '</ul><br /><br /><br />';
				echo ($upload_count?$ret:'');
				//exit;
			}
		}
	}

	//add_filter('woocommerce_email_recipient_customer_processing_order', 'wc_cc_store_email', 1, 2);

	add_action( 'woocommerce_email_before_order_table', 'add_order_attachments', 10, 2 );

	if(!function_exists('easy_ufdc_box_order_detail')){
		function easy_ufdc_box_order_detail($post) {
			
			
			$ret = '';
			$upload_count_outer = 0;
			
			if(is_numeric($post)):
				$order_id = $post;
				$order = new WC_Order($post);			
			else:
				if($post instanceof WP_Post):
					$order = new WC_Order($post->ID);
					$order_id = $order->get_id();
				else:
					$order = $post;
					$order_id = $order->get_id();
				endif;
			endif;	
			
			//pre(get_post_meta( $post->ID));
			$j=1;
			/* per product een formulier met gegevens */
			foreach ( $order->get_items() as $order_item ) {				
				$max_upload_count=1;
				//$max_upload_count=get_max_upload_count_plus($order,$order_item['product_id']);

			
				$forproduct = $order_item['name'];
				$ret .= '<strong>';
				$ret .= sprintf( __('File for product','easy-upload-files-during-checkout').': "%s"', $forproduct);
				$ret .= '</strong><br>';

				/* Controle of er al een bestand is geupload */

				$i=1;
				$upload_count=0;
				$ret .= '<ul>';
				while ($i <= $max_upload_count) {
					$ret .= '<li>';
					$name = get_post_meta( $order_id, '_woo_ufdc_uploaded_file_name_' . $j, true );					
					$uploaded_file_path = get_post_meta( $order_id, '_woo_ufdc_uploaded_file_path_' . $j, true );		
					//pre($uploaded_file_path);					
					
					$uploaded_file_path = str_replace(array('http:', 'https:'), '', $uploaded_file_path);
					$url = str_replace( ABSPATH, home_url('/'),  $uploaded_file_path);
					$url = (strpos($url, home_url('/'))?$url:home_url('/').$url);
					
					$forproduct = get_post_meta( $order_id, '_woo_ufdc_uploaded_product_name_' . $j, true );
					if( !empty( $url ) && !empty( $name ) ) {
						$url = eufdc_secure_download_link($order_id, $j, $url);
						$ret .= sprintf( '<a href="%s" target="_blank">%s</a>', $url, $name );
						$upload_count++;
						$upload_count_outer++;
					} else {
						//silence is golden
					}
				$i++;
				$j++;
					$ret .= '</li>';
				}
				$ret .= '</ul>';
			//}
			}
			
			echo ($upload_count_outer?$ret:'');
		}
	}

	function get_max_upload_count_plus($order,$order_item=0) {
		$max_upload_count=0;
		//product specifiek
		if( 
			(
				(
					is_array( get_option( 'easy_umf_status' )
				) 
				&& 
				in_array( $order->status, get_option( 'easy_umf_status' ) ) ) 
			) 
				|| 
				$order->status == get_option( 'easy_umf_status' ) 
		){
			if($order_item!=0) {
				$product = easy_umf_get_product($order_item);
				if( easy_umf_get_product_meta($product,'woo_umf_enable') == 1) {
					$max_upload_count=1;
				}
			} else {
			// order totaal
			foreach ( $order->get_items() as $order_item ) {
				$product = easy_umf_get_product($order_item['product_id']);
				$limit=1;
				if( easy_umf_get_product_meta($product,'woo_umf_enable') == 1 && $limit > 0 ) {
					$max_upload_count+=$limit;
				}
			}
			}
		}
		return $max_upload_count;
	}

	function ufdc_plugin_links($links) { 
		global $ufdc_premium_link, $ufdc_custom;
		$settings_link = '<a href="admin.php?page=easy_ufdc">' . __("Settings",'easy-upload-files-during-checkout') . '</a>';
		if($ufdc_custom){
			array_unshift($links, $settings_link); 
		}else{
			$ufdc_premium_link = '<a href="'.$ufdc_premium_link.'" title="' . __('Go Premium','easy-upload-files-during-checkout') . '" target=_blank>' . __("Go Premium",'easy-upload-files-during-checkout') . '</a>'; 
			array_unshift($links, $settings_link, $ufdc_premium_link); 
		}
		return $links; 
	}
	
	function eufdc_header_scripts(){
?>
	<style type="text/css">
	<?php
		if(get_option('eufdc_shipping_off', 0)){
?>
			.woocommerce-shipping-fields{
				display:none;	
			}
<?php			
		}
		if(get_option('eufdc_billing_off', 0)){
?>
			.woocommerce-billing-fields{
				display:none;	
			}
<?php			
		}
		if(get_option('eufdc_order_comments_off', 0)){
?>
		.woocommerce-additional-fields{
			display:none;
		}
<?php			
		}				
	?>
	</style>
<?php		
	}
	
	add_action('wp_head', 'eufdc_header_scripts');
	
	add_filter( 'woocommerce_checkout_fields' , 'eufdc_override_checkout_fields' );
	
	function eufdc_override_checkout_fields( $fields ) {
	
		if(get_option('eufdc_shipping_off', 0)){
			unset($fields['shipping']['shipping_first_name']);
			unset($fields['shipping']['shipping_last_name']);
			unset($fields['shipping']['shipping_company']);
			unset($fields['shipping']['shipping_address_1']);
			unset($fields['shipping']['shipping_address_2']);
			unset($fields['shipping']['shipping_city']);
			unset($fields['shipping']['shipping_postcode']);
			unset($fields['shipping']['shipping_country']);
			unset($fields['shipping']['shipping_state']);
			unset($fields['shipping']['shipping_phone']);	
			unset($fields['shipping']['shipping_address_2']);
			unset($fields['shipping']['shipping_postcode']);
			unset($fields['shipping']['shipping_company']);
			unset($fields['shipping']['shipping_last_name']);
			unset($fields['shipping']['shipping_email']);
			unset($fields['shipping']['shipping_city']);	
		}
		
		if(get_option('eufdc_billing_off', 0)){
			unset($fields['billing']['billing_first_name']);
			unset($fields['billing']['billing_last_name']);
			unset($fields['billing']['billing_company']);
			unset($fields['billing']['billing_address_1']);
			unset($fields['billing']['billing_address_2']);
			unset($fields['billing']['billing_city']);
			unset($fields['billing']['billing_postcode']);
			unset($fields['billing']['billing_country']);
			unset($fields['billing']['billing_state']);
			unset($fields['billing']['billing_phone']);	
			unset($fields['billing']['billing_address_2']);
			unset($fields['billing']['billing_postcode']);
			unset($fields['billing']['billing_company']);
			unset($fields['billing']['billing_last_name']);
			unset($fields['billing']['billing_email']);
			unset($fields['billing']['billing_city']);
		}
		
		if(get_option('eufdc_order_comments_off', 0))
		unset($fields['order']['order_comments']);
		
		return $fields;
	}
	
	function wdm_my_custom_notes_on_single_order_page($order){

       	$note = easy_ufdc_box_order_detail($order);
		$order->add_order_note( $note );

    }

    add_action( 'woocommerce_order_details_after_order_table', 'wdm_my_custom_notes_on_single_order_page',10,1 );	
	
	function eufdc_secure_download_link($post_id, $j, $url){
		//pree(' < '.$post_id.' - '.$j.' - '.$url.' > '.get_option('eufdc_secure_links', 0));
		if(!is_admin() && get_option('eufdc_secure_links', 0)){
			$url = home_url('/?eufdc='.base64_encode($post_id.'.'.$j));		
		}
		return $url;
	}
	
	function eufdc_translate_file_link(){
		$eufdc = $_GET['eufdc'];
		$eufdc = ($eufdc!=''?base64_decode($eufdc):'');
		
		$eufdc = explode('.', $eufdc);
		if(count($eufdc)==2){
			list($post_id, $j) = $eufdc;
			
			$theFile = '';
			
			if($j==0){
				global $wpdb, $woocommerce;
				
				$files = get_eufdc_uploaded_files(0, $post_id);
				if(!empty($files)){
					$files = current($files);
					$theFile = str_replace(home_url('/'), ABSPATH, $files->guid);
					//pree($files);exit;
				}
				//pree($files);exit;
				
			}else{
				$theFile = ABSPATH.get_post_meta( $post_id, '_woo_ufdc_uploaded_file_path_' . $j, true );
			}
			if($theFile!='' && file_exists($theFile)){
				
				
							
				$file_url  = stripslashes( trim( $theFile ) );
				//get filename
				$file_name = basename( $theFile );
				//get fileextension
				
				$file_extension = pathinfo($file_name);
				//security check
				$fileName = strtolower($file_url);
				
				$whitelist = apply_filters( "ibenic_allowed_file_types", array('png', 'gif', 'tiff', 'jpeg', 'jpg','bmp','svg') );
				
				if(!in_array(end(explode('.', $fileName)), $whitelist))
				{
				  exit('Invalid file!');
				}
				if(strpos( $file_url , '.php' ) == true)
				{
				  die("Invalid file!");
				}
				
				$file_new_name = $file_name;
				$content_type = "";
				//check filetype
				switch( $file_extension['extension'] ) {
					case "png": 
					  $content_type="image/png"; 
					  break;
					case "gif": 
					  $content_type="image/gif"; 
					  break;
					case "tiff": 
					  $content_type="image/tiff"; 
					  break;
					case "jpeg":
					case "jpg": 
					  $content_type="image/jpg"; 
					  break;
					default: 
					  $content_type="application/force-download";
				}
				
				$content_type = apply_filters( "ibenic_content_type", $content_type, $file_extension['extension'] );
				
				header("Expires: 0");
				header("Cache-Control: no-cache, no-store, must-revalidate"); 
				header('Cache-Control: pre-check=0, post-check=0, max-age=0', false); 
				header("Pragma: no-cache");	
				header("Content-type: {$content_type}");
				header("Content-Disposition:attachment; filename={$file_new_name}");
				header("Content-Type: application/force-download");
				
				readfile("{$file_url}");
				exit();				
			}
		}
	}
	
	if(isset($_GET['eufdc'])){
		
		add_action('wp', 'eufdc_translate_file_link');		
	}